package rogatkin.xbox.applet;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import rogatkin.xbox.io.*;
import rogatkin.xbox.shared.*;

public class AwtBtnPalette extends AwtFreePanel implements ActionListener {

    public AwtBtnPalette(int cols){
	Selection = -1;
	numCols = cols;
	setLayout(new GridLayout(0, numCols));
    }
	
    public void init() {
	if (MenuItems == null)
	    return;
	for (int i = 0; i< MenuItems.size(); i++) {
	    ToolButton tb = new ToolButton((String)MenuItems.elementAt(i),
		(MenuImages == null)?null:(Image)MenuImages.elementAt(i),
		(MenuTooltips == null)?null:(String)MenuTooltips.elementAt(i), i);
	    tb.addActionListener(this);
	    add(tb);
	}
    }
	
    public Dimension getMinimumSize() {
	return new Dimension(numCols*ButtonSize+numCols*2, ButtonSize*2+4);
    }
    
    public Dimension getPreferredSize() {
	if (MenuItems == null || MenuItems.size() == 0)
	    return getMinimumSize();
	else
	    return new Dimension(numCols*ButtonSize+numCols*2,
	    (ButtonSize+2)*((MenuItems.size()+numCols)/numCols));
    }
    
    public Vector getMenuItems() {
	return MenuItems;
    }
    
    public void setMenuItems(Vector v) {
	MenuItems = v;
    }
    
    public Vector getMenuImages() {
	return MenuImages;
    }
    
    public void setMenuImages(Vector v) {
	MenuImages = v;
    }
    
    public Vector getMenuTooltips() {
	return MenuTooltips;
    }
    
    public void setMenuTooltips(Vector v) {
	MenuTooltips = v;
    }
    
    public void setSelection(int s) {
	// unselect if something selected
	if (Selection >= 0)
	    ((ToolButton)getComponent(Selection)).setSelected(false);
	Selection = s;
	if (Selection >= 0)
	    ((ToolButton)getComponent(Selection)).setSelected(true);
    }
    
    public synchronized void addItemSelectedListener(ItemSelectedListener l)
    {
	ItemSelectedListeners.addElement(l);
    }
    
    public synchronized void removeItemSelectedListener(ItemSelectedListener l)
    {
	ItemSelectedListeners.removeElement(l);
    }
    
    public void actionPerformed(ActionEvent e){
	FireItemSelected(((ToolButton)e.getSource()).getIndex());
    }
    
    protected void FireItemSelected(int itemNumber)
    {
	Vector l;
	ItemSelectedEvent s = new ItemSelectedEvent (this, itemNumber);
	synchronized (this)
	{
	    l = (Vector) ItemSelectedListeners.clone();
	}
	for (int c=0;c<l.size();c++)
	{
	    ItemSelectedListener isl = (ItemSelectedListener)l.elementAt(c);
	    isl.selected(s);
	}
    }
    
    private Vector ItemSelectedListeners = new Vector();
    private Vector MenuItems = null;
    private Vector MenuImages = null;
    private Vector MenuTooltips = null;
    private int Selection;
    
    private int numCols;
    public final static int ButtonSize = 20;
    
}

class ToolButton extends Button {
    private int index;
    private Image image;
    public ToolButton(String name, Image image, String tooltip, int index) {
	this.image = (image == null)?ImageHelper.loadImage("defctrli.gif", false):image;
	this.index = index;
	//setPreferredSize(new Dimension(ToolBtnPalette.ButtonSize, ToolBtnPalette.ButtonSize));
    }
    
    public int getIndex() {
	return index;
    }

    public void setSelected(boolean selected) {
    }

    public void paint(Graphics g) {
	Dimension d = getSize();
	g.drawImage(image, 2, 2, d.width-4, d.height-4, this); 
    }
}