package rogatkin.xbox.applet;

import java.awt.*;
import java.beans.*;
import java.applet.Applet;
import java.io.File;
import java.net.URL;
import java.net.MalformedURLException;

import rogatkin.xbox.io.*;
import rogatkin.xbox.ui.*;
import rogatkin.xbox.core.*;
import rogatkin.xbox.creator.*;
import rogatkin.xbox.ut.WindowCloser;
import rogatkin.xbox.ut.XMLToolFactory;
import rogatkin.xbox.shared.Constants;

public class Entry extends Applet {
    String formUrl;
    boolean isApplication = false;
    StatusLine statusLine;
    AwtToolBox toolBox;
    
    public Entry() {
	// aelfred parser hardcoded
	ArchiveXML.PARSER = XMLToolFactory.AELFRED_PARSER;
	ArchiveXML.DOM = XMLToolFactory.AELFRED_DOM;
    }

    public void init() {
	//AppletContext ac = getAppletContext();
	String jdir = null;
	try {
	    jdir = getParameter("jarsdir");
	    if (jdir != null)
		CompManager.setJarsdirParm(jdir);
	} catch(Exception e) {
	}
        formUrl = getParameter("form");
	
	if (!isApplication)
	    ImageHelper.init(this);
	// Create a ControlsManager and load the jar files.
	CompManager formmanager = new CompManager();
	setLayout(new BorderLayout());
	
	try {
	    System.err.println("prepare for basic panel");
	    formmanager.buildControlList(null, CompManager.getJarsdirParm(), getDocumentBase());
	    BasicPanel basicpanel = null;
	    if(!isApplication)
		basicpanel = new AwtBasicPanel();
	    basicpanel.init(formmanager);
	    WorkSpace ws = basicpanel.getWorkSpace();
	    ws.setFrame((Frame)getParent());
	    // Set to the design mode.
	    ws.setDesignTime(true);
	    toolBox = new AwtToolBox(ws);
	    ws.setToolBox(toolBox);
	    ws.setStatusInfo(statusLine = new StatusLine());
	    Panel toolPanel = new Panel();
	    toolPanel.setLayout(new BorderLayout());
	    toolPanel.add(new AwtEditTool(ws), "East");
	    toolPanel.add(toolBox, "West");
	    toolPanel.add(new Panel()/*customizer*/, "South");
	    add((Component)basicpanel, "Center");
	    add(statusLine, "South");
	    add(toolPanel, "West");
	    System.err.println("basic panel added");
	    // load form 
	    try {
		basicpanel.getWorkSpace().loadXML(new URL(formUrl));
	    } catch (MalformedURLException mfue) {
	    }
	} finally {
	}
    }
    
    public String getInfo ()  {
	String s = "Layout editor applet\r\n";
	s += "Version: 1.0.1\r\n";
	return s;
    }
}
