/*
 * File:	CalcControl.java
 * Author:	Dmitry Rogatkin
 * Date:	03/12/98
 *
 * Copyright (C) 1998 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.flash.net/~dima/java/
 */
package rogatkin.xbox.components;

import com.ms.ui.*;
import com.ms.ui.event.*;

import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Vector;

import rogatkin.xbox.shared.IBindingList;
import rogatkin.xbox.shared.IFCEvListener;
import rogatkin.xbox.shared.FCEvent;
import rogatkin.xbox.shared.Constants;

public class CalcControl  extends UIPushButton 
implements IUIActionListener, IBindingList {
	String [] mathop = {"+", "-", "*", "/", "="};
	String [] mathexpl = {"Addition", "Substraction", "Multiplication", "Division", "Equality"};
	public CalcControl(){
		setText("Calculate");
	}
	public void setText(String name){
		Text = name;
		setName(Text);
	}
	
	public String getText(){
		return Text;
	}
	
	public  boolean	isBuiltList(){
		return true;
	}

	public  void getBuiltList(boolean on){
	}

	public  int getElementsCount(){
		return 5;
	}

	public  void setElementsCount(int c){
	}

	public  String getElementNames(int index){
		return mathop[index];
	}

	public  String[] getElementNames(){
		return mathop;
	}
	
	public  void setElementNames(String[] names){
	}

	public  void setElementNames(int index, String name){
	}
	
	public  String getElementInfos(int index){
		return mathexpl[index];
	}
	
	public  String[] getElementInfos(){
		return mathexpl;
	}
	
	public  void setElementInfos(String [] names){
	}
	
	public  void setElementInfos(int index, String name){
	}

    public String getTableName(){
        return null;
    }
	
    public void setTableName(String name){
    }

    
	public void actionPerformed(UIActionEvent ae){
		ctrlslist = new Hashtable(12);
		fireCommand(null, Constants.CMDGetBindedElements, null, ctrlslist);
		Enumeration ten = ctrlslist.keys();
		while (ten.hasMoreElements()) {
			String tbl = (String)ten.nextElement();
			Vector fields = (Vector)ctrlslist.get(tbl);
			// fields has to be sorted by 3rd string
			if (fields == null)
				continue;
			
			String []compns;
			int result = 0;
			int term = 0;
			String resName = null;
			String resProp = null;
			Object []propvals = new Object[2];
			for (int i = 0; i < fields.size(); i++) {
				compns = (String[])fields.elementAt(i);
				propvals[0] = compns[1]; // prop name
				fireCommand(null, Constants.CMDGetPropertyFor, compns[0], propvals); // bean name
				
				if (propvals[0] instanceof Integer) {
                                    	term = ((Integer)propvals[0]).intValue();
				}else try{
					term = Integer.parseInt((String)propvals[0]);
				}catch (NumberFormatException en){
                    System.err.println(en+" happened when data retrieving from '"+propvals[0]+"'");
					term = 0;
				}catch (Exception e){
                    System.err.println(e+" happened when data retrieving");
					term = 0;
				}
                                if(i==0 && (compns[2].equals("*") || compns[2].equals("/"))) {
                                            result = term; continue;
                                        }

				if (compns[2].equals("+"))
					result += term;
				else if (compns[2].equals("-"))
					result -= term;
				else if (compns[2].equals("*"))
					result *= term;
				else if (compns[2].equals("/"))
					result /= term;
				else if (compns[2].equals("=")){
					resName = compns[0];
					resProp = compns[1];
				}
			}
			if (resName != null){
				propvals[1] = String.valueOf(result);
				propvals[0] = resProp;
				fireCommand(null, Constants.CMDSetConvPropertyFor, resName, propvals);
			}
		}
	}
	
	//---------------------------------------------------------
	public void addCommandListener(IFCEvListener l) throws java.util.TooManyListenersException {
		if (container != null)
			throw new java.util.TooManyListenersException();
		container = l;
	}
	
	public void removeCommandListener(IFCEvListener l){
		container = null;
	}
	
	public void fireCommand(String com, int code, String name, Object data){
		// we do not need synchronize, because we use just one listener
		if (container == null)
			return;
		container.Command(new FCEvent(this, com, code, name, data));
	}
	
	private IFCEvListener container = null;
	private Hashtable ctrlslist;
	String Text;
}