/*
 * File:		DigitalPictureBeanInfo.java
 *
 * Description:	DigitalPictureBeanInfo : info for DigitalPicture
 * 
 *
 * Copyright (C) 2000 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://drogatkin.openestate.net/
 */
package rogatkin.xbox.components;


import java.beans.*;
import javax.swing.*;

public class DigitalPictureBeanInfo extends SimpleBeanInfo {
    final static String IMAGEDIR = "images/";
    public java.awt.Image getIcon(int iconKind) {
	if (iconKind == BeanInfo.ICON_COLOR_16x16) {
	    java.awt.Image img = loadImage(IMAGEDIR+"DigitalPictureColor16.gif");
	    return img;
	}
	return null;
    }
    
    public PropertyDescriptor[] getPropertyDescriptors() {
	try {
            PropertyDescriptor 
                result[] = { new PropertyDescriptor("BorderName", DigitalPicture.class),
                             new PropertyDescriptor("Icon", JLabel.class),
                             new PropertyDescriptor("ImageLocation", DigitalPicture.class),
                             new PropertyDescriptor("SVGString", DigitalPicture.class)
	    };
            result[0].setPropertyEditorClass(BorderEditor.class);
	    return result;
	} catch(Exception e) {
	    System.err.println("DigitalPictureBeanInfo: unexpected exception "+e);
	}
	return null;
    }
     
    public BeanDescriptor getBeanDescriptor()
    {
        return new BeanDescriptor(DigitalPicture.class, DigitalPictureCustomizer.class);
    }
}