/*
 * File:		rfBtn.java
 *
 * Description:	rfBtn : implements button
 *
 * Copyright (C) 1998 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.flash.net/~dima/java/
 */
package rogatkin.xbox.components;

import java.awt.Dimension;
import java.awt.SystemColor;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.*;

import rogatkin.xbox.shared.IFCEvListener;
import rogatkin.xbox.shared.FCEvent;
import rogatkin.xbox.shared.Constants;

public class rfBtn extends JButton 
implements ActionListener {
	private String FormName;
	private java.util.Vector xCommandListeners = new java.util.Vector();
	String ColorOfChoice = "Red";
	
	public rfBtn(){
		setText("Button");
		setFormName("");
	}
	
	public Dimension getMinimumSize() {
		return new Dimension(40, 24);
	}
	
	public String getFormName(){
		return FormName;
	}
	
	public void setFormName(String text){

		FormName = text.replace('\\', File.separatorChar).replace('/', File.separatorChar);
	}
	
    public void setToolTipText(String text) {
        super.setToolTipText(text);
    }

    public String getToolTipText() {
        return (super.getToolTipText() == null)?"":super.getToolTipText();
    }

	public String getColorOfChoice(){
		return ColorOfChoice;
	}
	
	public void setColorOfChoice(String c){
		ColorOfChoice = c;
	}
	
	public void actionPerformed(ActionEvent e){
		fireBtnEvent();
		fireCommand(null, Constants.CMDLoadPage, getFormName(), null);
	}
	
	void fireBtnEvent(){
		java.util.Vector l;
		xCommandEvent s = new xCommandEvent (this, getColorOfChoice());
		synchronized (this)
		{
			l = (java.util.Vector) xCommandListeners.clone();
		}
		for (int c=0;c<l.size();c++)
		{
			xCommandListener dal = (xCommandListener)l.elementAt(c);
			dal.xCommandAction(s);
		}
	}
	
	public synchronized void addxCommandListener(xCommandListener l)
	{
		xCommandListeners.addElement(l);
	}
	
	public synchronized void removexCommandListener(xCommandListener l)
	{
		xCommandListeners.removeElement(l);
	}
	
	public synchronized void addCommandListener(IFCEvListener l) throws java.util.TooManyListenersException {
		if (container != null)
			throw new java.util.TooManyListenersException();
		container = l;
	}
	
	public synchronized void removeCommandListener(IFCEvListener l){
		if (l == container)		
			container = null;
	}
	
	private IFCEvListener container = null;
	
	public void fireCommand(String com, int code, String name, Object data){
		// we do not need synchronize, because we use just one listener
		if (container == null)
			return;
		synchronized (this){
			container.Command(new FCEvent(this, com, code, name, data));
		}
	}
}