/*
 * File:		rfBtnBeanInfo.java
 * Author:	Dmitry Rogatkin
 * Date:		03/12/98
 *
 * Copyright (C) 1998 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.flash.net/~dima/java/
 */
package rogatkin.xbox.components;

import java.beans.*;

public class rfBtnBeanInfo extends SimpleBeanInfo {
	final static String IMAGEDIR = "images/";
    public java.awt.Image getIcon(int iconKind) {
		if (iconKind == BeanInfo.ICON_COLOR_16x16) {
			java.awt.Image img = loadImage(IMAGEDIR+"rfBtnIconColor16.gif");
			return img;
		}
		return null;
    }

	public PropertyDescriptor[] getPropertyDescriptors() {
		try {
			PropertyDescriptor pd = new PropertyDescriptor( 
				"ColorOfChoice", rfBtn.class);
			pd.setPropertyEditorClass(xListOfColors.class);
			PropertyDescriptor result[] = { pd,
				new PropertyDescriptor("Background",javax.swing.JButton.class),
				new PropertyDescriptor("Foreground",javax.swing.JButton.class),
				new PropertyDescriptor("Font", javax.swing.JButton.class),
                new PropertyDescriptor("Opaque",javax.swing.JComponent.class),
                new PropertyDescriptor("ToolTipText",rfBtn.class),
				new PropertyDescriptor("FormName", rfBtn.class),
				new PropertyDescriptor("Text", javax.swing.AbstractButton.class)
				};
			return result;
		}catch(Exception e) {
			System.err.println("rfBtnBeanInfo: unexpected exception "+e);
		}
		return null;
	}
}
