/*
 * File:	rfLabel.java
 * Author:	Dmitry Rogatkin
 * Date:	05/22/98
 *
 * Copyright (C) 1998-2000 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://drogatkin.openestate.net/
 */
package rogatkin.xbox.components;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.SystemColor;
import java.awt.Color;
import java.awt.Font;

import javax.swing.*;

public class rfLabel extends JLabel implements xCommandListener {
	public rfLabel(){
		setText("Label");
		style = "left";
	}

	public Dimension getMinimumSize() {
		return new Dimension(80, 12);
	}

	public void xCommandAction (xCommandEvent e){
		String c = e.getxColorCommand();
		//System.err.println("Command received "+c);
		if (c.equals("Red"))
			setBackground(Color.red);
		else if (c.equals("Blue"))
			setBackground(Color.blue);
		else if (c.equals("Black"))
			setBackground(Color.black);
		else if (c.equals("Green"))
			setBackground(Color.green);
		else if (c.equals("Yellow"))
			setBackground(Color.yellow);
		else if (c.equals("White"))
			setBackground(Color.white);
		repaint();
	}

	public String getStyle() {
		switch (getHorizontalAlignment())
		{
		case SwingConstants.LEFT:
			style = xStyleTags.STYLETAGS[0];
			break;
		case SwingConstants.RIGHT:
			style = xStyleTags.STYLETAGS[1];
			break;
		case SwingConstants.CENTER:
			style = xStyleTags.STYLETAGS[2];
			break;
		default:
			style = xStyleTags.STYLETAGS[0];
		}
		return style;
	}
	
	public void setStyle(String style){
		this.style = style;
		if(xStyleTags.STYLETAGS[0].equals(style))
			setHorizontalAlignment(SwingConstants.LEFT);
		else if(xStyleTags.STYLETAGS[1].equals(style))
			setHorizontalAlignment(SwingConstants.RIGHT);
		else if(xStyleTags.STYLETAGS[2].equals(style))
			setHorizontalAlignment(SwingConstants.CENTER);
	}

    public String getSVGString() {
        //Rectangle r = getBounds();
        Dimension d = getSize();
        Point p;
        if (java.beans.Beans.isDesignTime())
            p = getParent().getLocation();
        else
            p = getLocation();
        StringBuffer result = new StringBuffer(40);
        result.append("<text x=\"");
        result.append(p.x).append("\" y=\"").append(p.y);
        Font f = getFont();
        String hs = Integer.toHexString(getForeground().getRGB() & 0xffffff);
        while (hs.length() < 6)
            hs = "0"+hs;
	result.append("\" style=\"fill:#").append(hs);
	result.append("; font-family:").append(f.getName()).append("; font-size:"+f.getSize());
	result.append("; font-style:").append(f.getStyle());
	result.append("; text-align:").append(style);
        result.append("\"> \n ");
        result.append(getText());
        result.append("</text>");
        return result.toString();
    }
    
    public void setSVGString(String s) {
    }
        
	private String style;
}
