/*
 * File:	rfTableBeanInfo.java
 * Author:	Dmitry Rogatkin
 * Date:	04/30/98
 *
 * Copyright (C) 1998 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.flash.net/~dima/java/
 */
package rogatkin.xbox.components;

import java.beans.*;
import javax.swing.*;

public class rfTableBeanInfo extends SimpleBeanInfo {
	final static String IMAGEDIR = "images/";
    public java.awt.Image getIcon(int iconKind) {
		if (iconKind == BeanInfo.ICON_COLOR_16x16) {
			java.awt.Image img = loadImage(IMAGEDIR+"rfTableColor16.gif");
			return img;
		}
		return null;
    }

	public PropertyDescriptor[] getPropertyDescriptors() {
		try {
			PropertyDescriptor pd = new PropertyDescriptor( 
				"LookAndFeel", rfTable.class);
			pd.setPropertyEditorClass(LookAndFeelNameEditor.class);

            PropertyDescriptor result[] = { pd,
				new PropertyDescriptor("TableBackground", rfTable.class),
				new PropertyDescriptor("TableForeground", rfTable.class),
				new PropertyDescriptor("TableFont", rfTable.class),
                new PropertyDescriptor("SelectionBackground", rfTable.class),
                new PropertyDescriptor("ShowGrid", rfTable.class),
                new PropertyDescriptor("NumRows", rfTable.class),
                new PropertyDescriptor("NumCols", rfTable.class),
                new PropertyDescriptor("Row", rfTable.class),
                new PropertyDescriptor("Col", rfTable.class),
				new PropertyDescriptor("CellString", rfTable.class),
				new PropertyDescriptor("Contents", rfTable.class),
				new PropertyDescriptor("Headers", rfTable.class),
				new PropertyDescriptor("Header", rfTable.class),
                new PropertyDescriptor("Types", rfTable.class),
                new PropertyDescriptor("Type", rfTable.class),
                new PropertyDescriptor("ColWidths", rfTable.class),
                new PropertyDescriptor("ColWidth", rfTable.class)
            };
			return result;
		}catch(Exception e) {
			System.err.println("rfTableBeanInfo: unexpected exception "+e);
		}
		return null;
	}
}