/*
 * File:		rfTabs.java
 *
 * Description:	rfTabs implements tab control
 *
 * Copyright (C) 1998 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.flash.net/~dima/java/
 */
package rogatkin.xbox.components;

import java.awt.Dimension;

import javax.swing.*;

public class rfTabs extends JTabbedPane {
    int selection;
    JPanel panel = new JPanel();
    public rfTabs() {
	//base = new BaseChoice();
    }
    
    public String[] getLabels() {
	int n = getTabCount();
	String [] result = new String[n];
	for (int i=0; i<n; i++)
	    result[i] = getTitleAt(i);
	return result;
    }
    
    public void setLabels(String [] labels) {
	removeAll();
	for (int i=0; i<labels.length; i++)
	    insertTab(labels[i], null, null, "tab"+i, i);
	if (selection < labels.length)
	    setSelection(selection);
    }

    public void setSelection(int selection) {
	if (selection < getTabCount())
	    setSelectedIndex(selection);
        this.selection = selection;
    }
    
    public int getSelection() {
	return getSelectedIndex();
    }
    
    public void setLabel(String text) {
	if (getTabCount() > 0)
	    setTitleAt(getSelection(), text);
    }
    
    public String getLabel() {
	if (getTabCount() > 0)
	    return getTitleAt(getSelection());
	else
	    return "";
    }

    public String getPlacement() {
	switch (getTabPlacement())
	{
	case SwingConstants.BOTTOM:
	    return xStyleTags.STYLETAGS[4];
	case SwingConstants.LEFT:
	    return xStyleTags.STYLETAGS[0];
	case SwingConstants.RIGHT:
	    return xStyleTags.STYLETAGS[1];
	case SwingConstants.TOP:
	    return xStyleTags.STYLETAGS[3];
	}
        return xStyleTags.STYLETAGS[3];
    }

    public void setPlacement(String place) {
	if (xStyleTags.STYLETAGS[0].equals(place))
	    setTabPlacement(SwingConstants.LEFT);
	else if (xStyleTags.STYLETAGS[1].equals(place))
	    setTabPlacement(SwingConstants.RIGHT);
	else if (xStyleTags.STYLETAGS[4].equals(place))
	    setTabPlacement(SwingConstants.BOTTOM);
	else
	    setTabPlacement(SwingConstants.TOP);
    }

    public void setTabs(int size) {
        int n = getTabCount();
	if (n < size)
	{
	    for (int i=n; i<size; i++) {
		insertTab("tab"+i, null, null, "tab"+i, i);
	    }
	}
	else
	    for (int i=n-1; i>size-1; i--)
		removeTabAt(i);
    }
    
    public int getTabs() {
	return getTabCount();
    }

    //class ChoicesModel extends AbstractListModel {
    //}

}
