/*
 * File:	ALabel.java
 * Author:	Dmitry Rogatkin 
 * Date:	02/19/98
 * $Version:  1.0
 * $Description:	visible implementation fo invisible beans 
 *
 * Copyright (C) 1998 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.flash.net/~dima/java/
 */
package rogatkin.xbox.core;

import java.awt.*;

/**
 * OurLabel draws a string to reprensent an invisible bean.
 *
 * It differs from java.awt.Label in that it forwards mice events
 * up to its container, which makes it friendlier in the BeanBox.
 */
public class ALabel extends Component {
	
    public ALabel(String label) {
		this.label = label;
		Font f = new Font("Helvetica", Font.PLAIN, 10);
		setFont(f);
    }
	
    public Dimension getPreferredSize() {
		FontMetrics fm = getFontMetrics(getFont());
		baseline = fm.getMaxAscent() + 2;
		int height = baseline + fm.getMaxDescent() + 2;
		int width = fm.stringWidth(label) + 17;

		return new Dimension(width,height);
    }
	
	public void setLabel(String label)
	{
		this.label = label;
		repaint();
	}

    public void paint(Graphics g) {
		g.drawString(label, 3, baseline);
    }
	
    private String label;
    private int baseline;
}
