/*
 * File:		BListManager.java
 * Date:		2/18/98
 * Author:		Dmitriy Rogatkin 
 *
 * Version:     1.0
 * Revision:    0.0
 * History:
 *           
 * Description: prepares binding list for bean requester
 *				
 * Copyright (C) 1998 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.flash.net/~dima/java/
 */
package rogatkin.xbox.core;

import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;

public class BListManager {
	private final boolean usePrepared = true;
	private WorkSpace beanbox;
	
	BListManager(WorkSpace bc){
		beanbox = bc;
	}
	
	void prepareExchangeData(Hashtable dbcs, String ctrlname, Hashtable ctrltbl){
	/*
	controls (hashtable)
	tables (hashtable)
	control property fields (string[3]) (should be sorted by controls for speed too)
		*/
		if (dbcs == null)
			dbcs = new Hashtable(10);
		else
			dbcs.clear();
		for (int i = 0; i < beanbox.getComponentCount(); i++) {
			Wrapper w = (Wrapper)beanbox.getComponent(i);
			Hashtable binds = w.getdbBinds();
			if (binds == null)
				continue;
			Enumeration en = binds.keys(); //elements();
			if (en == null) // no bindings
				continue;
			
			while (en.hasMoreElements()){
				String pr = (String)en.nextElement();
				String []tr = (String [])binds.get(pr);
				//System.err.println("Triple: "+tr[0]+","+tr[1]+","+tr[2]);
				if (tr != null) {
					Vector conts = null;
					Hashtable tbls = (Hashtable)dbcs.get(tr[2]); // control
					if (tbls == null){
						if (tr[2].equals(ctrlname))
							tbls = ctrltbl;
						else
							tbls = new Hashtable(1);
						
						conts = new Vector(10);
						tbls.put(tr[1], conts); // table
						dbcs.put(tr[2], tbls);
					} else {
						conts = (Vector)tbls.get(tr[1]);
						if (conts == null){
							conts = new Vector(10);
							tbls.put(tr[1], conts);
						}
					}
					String [] rr = new String[3];
					rr[0] = w.getDesignName();
					rr[1] = pr; // propery 
					rr[2] = tr[0]; // field
					int ix = findElementWithField(conts, tr[0]);
					//	System.err.println("element '"+tr[0]+"' was found at "+ix);
					//	System.err.println("c "+rr[0]+ " p "+rr[1]+" f "+rr[2]);
					conts.insertElementAt(rr, ix);
				}
			}
		}
	}
	
	int findElementWithField(Vector gv, String fl){
		int bn = gv.size(); // upper bound
		//		System.err.println("Find '"+fl+"' in "+bn);
		if (bn == 0)
			return bn;
		int cm; // comparision
		int ix = bn/2;
		int st = ix; // current index
		if (st <= 2) st = 2;
		String[] sa; // temp variable
		//try{
		while (true){
			st /= 2;
			sa = (String[])gv.elementAt(ix);
			cm = fl.compareTo(sa[2]);
			//System.err.println("index "+ix+" step "+st+" comparision "+cm);
			if (cm < 0){ // step to start
				if (ix == 0)
					return ix;
				if (st == 0){
					sa = (String[])gv.elementAt(ix-1);
					if (fl.compareTo(sa[2]) < 0) ix--;
					return ix;
				}
				ix -= st;
				continue;
			}
			if (cm > 0){
				if (ix == (bn-1))
					return bn;
				if (st == 0){
					sa = (String[])gv.elementAt(ix+1);
					if (fl.compareTo(sa[2]) > 0) ix++;
					return ix+1;
				}
				ix += st;
				continue;
			}
			return ix;
		}
		//}catch(Exception e){ System.err.println("Ex: "+e); return 0;}
	}
}
