/*
 * File:	IntArrayPropEditor.java
 * Author:	Dmitry Rogatkin
 * Date:	05/06/98
 *
 * Description:	IntArrayPropEditor implementation 
 *				
 * Copyright (C) 1998 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.flash.net/~dima/java/
 */
package rogatkin.xbox.creator;

/**
 * Special case property editor for Sring Arrays.
 */

public class IntArrayPropEditor
extends java.beans.PropertyEditorSupport {
    String[] tags;
    public String[] getTags() {
        int[] values = (int[])getValue();
		tags = null;
		tags = new String[values.length];
		for (int i = 0; i< values.length; i++)
			tags[i] = String.valueOf(values[i]);

        return tags;
    }
    
    public void setAsText(String text) throws IllegalArgumentException {
        if (!(text instanceof String))
            throw new IllegalArgumentException(text);
        try {
			selectedValue = Integer.parseInt(text);
		} catch (NumberFormatException e) {
			throw new IllegalArgumentException(text);
		}
        firePropertyChange();
    }
    
    public String getAsText()
    {
        return String.valueOf(selectedValue);
    }
    
    private int selectedValue;
}
