/*
 * File:	PropertyElement.java
 * Author:	Dmitry Rogatkin
 * Date:	03/30/98
 *
 * Description:	keeps all information about editable propert
 *				
 *
 * Copyright (C) 1998-2000 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://drogatkin.openestate.net/
 */
package rogatkin.xbox.creator;

import java.beans.*;

class PropertyElement {
	final static int CANVAS = 1;
	final static int TEXT = 2;
	final static int CHOICE = 3;
	final static int NAME = 4;
	final static int CUSTOMIZER = 5;
	public PropertyElement(PropertyEditor e, Object v, String n, int t, PropertyDescriptor d){
		editor = e;
		value = v;
		name = n;
		type = t;
		descriptor = d;
	}

	PropertyEditor getPropertyEditor(){
		return editor;
	}

	Object getPropertyValue(){
		return value;
	}
	
	public void setPropertyValue(Object v){
		value = v;
	}

	String getPropertyName(){
		return name;
	}

	int getPropertyType(){
		return type;
	}
	
	public PropertyDescriptor getPropertyDescriptor(){
		return descriptor;
	}

	PropertyEditor editor;
	PropertyDescriptor descriptor;
	Object value;
	String name;
	int type;
}