/*
 * File:		Constants.java
 * Author:		Dmitry Rogatkin
 * Date:		03/12/98
 *
 * Description:	Constants
 *
 * Copyright (C) 1998-2000 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://drogatkin.openestate.net/
 */
package rogatkin.xbox.shared;

public class Constants {
    // commands
    static final public int CMDBuildBindingList = 1001;
    static final public int CMDGetBindedElements = 1002;
    static final public int CMDSetPropertyFor = 1003;
    static final public int CMDGetPropertyFor = 1004;
    static final public int CMDSetConvPropertyFor = 1005;
    static final public int CMDLoadPage = 1006;
    static final public int CMDNextRow = 1007;
    static final public int CMDSetRow = 1008;
    static final public int CMDTruncByCurrent = 1009;
    // command codes for bean container
    static final public int CMDOpen               = 100;
    static final public int CMDSave               = 101;
    static final public int CMDSerializeComponent = 102;
    static final public int CMDLoadJar            = 103;
    static final public int CMDReloadJars         = 104;
    static final public int CMDPrint              = 105;
    static final public int CMDCopy               = 106;
    static final public int CMDCut                = 107;
    static final public int CMDPaste              = 108;
    static final public int CMDDelete             = 109;
    static final public int CMDBringFwd           = 110;
    static final public int CMDBringBck           = 111;
    // internal command listener name
    static final public String COMMAND = "command";
    // strings
    static final public String PRODUCTID = "xBox";
    static final public String PRODUCT_ID = PRODUCTID;
    static final public String COMP_NAME = "Designer";
    static final public String COPYRIGHT = "Copyright 1998-2001";
    static final public String VERSION = rogatkin.xbox.core.BasicSpace.BASEVERSION;
    static final public String COMPANY_NAME = "Dmitriy Rogatkin";
    static final public String RESERVED = "All right reserved.";
    static final public String BUILD = rogatkin.xbox.core.BasicSpace.BUILD;
    static final public String ERRID = "xBox: ";
    // pathes
    static public class Internals {
	static final public String IMAGEPATH = "rogatkin/xbox/resources/images/";
    }
}