/*
 * File:		FCEvent.java
 * Author:		Dmitry Rogatkin
 * Date:		03/3/98
 *
 * Description:	FCEvent
 *
 * Copyright (C) 1998 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.flash.net/~dima/java/
 */
package rogatkin.xbox.shared;

public class FCEvent extends java.util.EventObject {
	private String Command;
	private int IDCommand;
	private String Param1;
	private Object Param2;

	public FCEvent (Object source)
	{
		super (source);
		Command = "";
		IDCommand = -1;
		Param1 = null;
		Param2 = null;
	}
	
	public FCEvent (Object source, String c)
	{
		super (source);
		Command = c;
	}

	public FCEvent (Object source, String c, int i)
	{
		this (source, c);
		IDCommand = i;
	}
	
	public FCEvent (Object source, String c, int i, String param1){
		this (source, c, i);
		Param1 = param1;
	}
	
	public FCEvent (Object source, String c, int i, String param1, Object param2)
	{
		this (source, c, i, param1);
		Param2 = param2;
	}
	
	public String getCommand()
	{
		return Command;
	}

	public int getIDCommand()
	{
		return IDCommand;
	}
	
	public String getParam1(){
		return Param1;
	}

	public Object getParam2(){
		return Param2;
	}
}