/*
 * File:		AboutDialog.java
 * Author:		Dmitry Rogatkin 
 * Date:		03/11/98
 *
 * Description:	About dlg box
 *
 * Copyright (C) 1998 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://drogatkin.openestate.net/
 */
package rogatkin.xbox.ui;

import javax.swing.*;
import java.awt.*;
import rogatkin.xbox.io.ImageHelper;
import rogatkin.xbox.shared.Constants;

/**
 * Pop up a (modal) dialog that talks about the xBox.
 */
public class AboutDialog {
    private final static String message = Constants.PRODUCT_ID+' '+Constants.COMP_NAME+' '+Constants.VERSION+'\n'
		+ Constants.COPYRIGHT+' '+Constants.COMPANY_NAME+'\n'
		+ Constants.RESERVED+'\n'
		+ Constants.PRODUCT_ID+' '+Constants.VERSION+Constants.BUILD+'\n'
		;

    public AboutDialog(Frame frame) {
		JOptionPane.showMessageDialog(frame, message,
			"About", JOptionPane.PLAIN_MESSAGE,
			new ImageIcon(ImageHelper.getImageURL("rfico.gif")));
    }
	
}
