/*
 * File:	OrderedQueue.java
 * Author:	Dmitry Rogatkin
 * Date:	04/28/98
 *
 * Description:	OrderedQueue implementation 
 *
 * Copyright (C) 1998 Dmitry Rogatkin.  All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the Dmitry Rogatkin's Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.flash.net/~dima/java/
 */
package rogatkin.xbox.ut;

import java.util.Vector;

public class OrderedQueue extends Vector {
    public final static int ANCESSOR = 0;
    public final static int DECESSOR = 1;
	private boolean order = false;
	
	public void setOrder(int order)
	{
		this.order = order == ANCESSOR;
	}

    public void push(int weight, Object object){
        ComponentHolder el = new ComponentHolder(weight, object);
		int ix = elementCount/2;
		int st = ix; // current index
		if (st <= 2) st = 2;
		while (elementCount > 0){
			st /= 2;
			if (el.compare((ComponentHolder)elementAt(ix)) ^ order){ // step to start
				if (ix == 0)
					break;
				if (st == 0){
					if (el.compare((ComponentHolder)elementAt(ix-1)) ^ order) ix--;
					break;
				}
				ix -= st;
				continue;
			}else {
                if (ix == (elementCount-1)) {
					 ix = elementCount;
                     break;
                }
				if (st == 0){
					if ((!el.compare((ComponentHolder)elementAt(ix+1))) ^ order) ix++;
					ix++;
                    break;
				}
				ix += st;
				continue;
			}
		}
		//System.err.println("El "+weight+" was put at "+ix);
        insertElementAt(el, ix);
    }
    
	public Object pop()	{
		Object result = null;
		if (elementCount > 0)
		{
			result = ((ComponentHolder)elementAt(size() - 1)).getObject();
			removeElementAt(elementCount - 1);
		}
        return result;
    }

}

class ComponentHolder {
    int weight;
    Object object;
    ComponentHolder(int weight, Object object){
        this.weight = weight;
        this.object = object;
    }
    int getWeight(){
        return weight;
    }
	Object getObject(){
		return object;
	}
    boolean compare(ComponentHolder holder)
    {
        return holder.getWeight() > weight;
    }
}